import { IfAny } from '@vue/shared';
import { Ref } from 'vue';
import { UnwrapRef } from 'vue';

declare type QueryParamType = string | number | boolean;

/**
 * Syncs a Vue ref with a URL query parameter.
 * @param key - The query parameter key
 * @param defaultValue - The default value if the query param is not present
 */
export declare function useQueryParam<T extends QueryParamType>(key: string, defaultValue: T): [T] extends [Ref<any, any>] ? IfAny<T, Ref<T, T>, T> : Ref<UnwrapRef<T>, T | UnwrapRef<T>>;

export { }
